Subject: PHP Catchable Fatal Error: t3lib_iconWorks::getSpriteIconForRecord() must be an array (workspaces 

situation)
Description

In Typo3 4.5.2, it is not possible to open some pages in the Web-Page-View.

This is the error message:
PHP Catchable Fatal Error: Argument 2 passed to t3lib_iconWorks::getSpriteIconForRecord() must be an array, null given, called in
typo3/sysext/cms/layout/class.tx_cms_layout.php on line 686 and defined in t3lib/class.t3lib_iconworks.php line 762

On the contrary, one can open the same pages in the Web-List-View. Also, other pages in the same page tree can easily be opened.

The above mentioned problem could be fixed by adding the following to line 686 of typo3/sysext/cms/layout/class.tx_cms_layout.php:
if (!is_array($lpRecord)) $lpRecord = array($lpRecord);

It happens in an environment with to defined languages and three workspaces. It is not possible to open the pages in the
Live-Workspace and the "Entwurfsarbeitsumgebung"-Workspace. But in the Draft-Workspace, one can open the page.
(issue imported from #M18010)

Related issues:
related to Core - Bug # 21084: Pages in Workspaces are not editable anymore, ... Closed 2010-08-09
related to Core - Bug # 39197: Pagetree Filtering can't handle records moved ... Resolved 2012-07-23
duplicates Core - Bug # 25409: t3lib_iconWorks::getSpriteIconForRecord() isn'... Closed 2011-03-28

History
#1 - 2011-05-26 10:13 - Max Mishyn
- Target version deleted (0)

Same issue takes place in getIcon($row) at t3lib/class.t3lib_treeview.php at line 633 (TYPO3 v 4.5.2).
BE users with administrative rights are not affected by this issue. One users with access defined by DM mounted points facing it.
I aw able to fix it by adding following condition check:

if (is_array($row)) {
    $icon = t3lib_iconWorks::getSpriteIconForRecord($this->table, $row, array(.....
}

#2 - 2011-08-25 19:27 - Arpad Fodor
Hi,

I also reproduced the error in the backend when some page content elements are in a workspace.

To provide a more hopefully general solution for this problem, I tried to fix the method getSpriteIconForRecord in the file t3lib/class.t3lib_iconworks.php
since this seems to be the cause for this error.

Current code:
public static function getSpriteIconForRecord($table, array $row, array $options = array()) {
  // Code of the method
}

Possible new code:
public static function getSpriteIconForRecord($table, $row, $options = array()) {
  if (!is_array($row) || count($row) < 1){
    return '';
  }
  // Code of the method
}

1. Remove the array in front of the parameter $row since this forces the caller to provide an array. As I counted ca. 87 usages of this method, it is
easier to do this.

2. do the check, if the given parameter $row is really an array and if it has any elements.

Please note:
These checks may not fix all issues...

#3 - 2011-09-07 15:28 - Fedir RYKHTIK
- File 25372.diff added

Confirmation of the issue.

Just had the same problem after upgrading of existing site from 4.4.4 to 4.4.10, so it's not only 4.5.x bug.

Site has WS configured, some workspaces had these issue, some not. Workspaces were configured with exactly the same parameters.

The bug was resolved locally with patch added into the attachment.

#4 - 2011-09-07 15:36 - Fedir RYKHTIK

Looks like it's related to #25409, probably comes from deleted elements

#5 - 2011-11-23 13:11 - Michael Fritz
- Target version set to 4.5.9

I just changed one line in class.tx_cms_layout.php and it words.

2015-08-04 2/4



OLD: $lPLabel = $GLOBALS['SOBE']->doc->wrapClickMenuOnIcon(t3lib_iconWorks::getSpriteIconForRecord('pages_language_overlay', $lpRecord),
$lpRecord['uid']) .
NEW: $lPLabel = $GLOBALS['SOBE']->doc->wrapClickMenuOnIcon(t3lib_iconWorks::getSpriteIconForRecord('pages_language_overlay',
is_array($lpRecord)?$lpRecord:array()), $lpRecord['uid']) .

#6 - 2012-01-24 15:40 - Ernesto Baschny
- Target version changed from 4.5.9 to 4.5.12

#7 - 2012-03-20 17:27 - Philipp Gampe

@Michael mind pushing a patch to gerrit?

#8 - 2012-03-25 21:28 - Jigal van Hemert

What is the reason the the pages_language_overlay record for that language is empty? Using an empty array is just masking the actual problem and
not a real solution.

#9 - 2012-04-18 11:27 - Bart Dubelaar

This bug is also affecting the filter function in the page tree when working in a draft workspace.

#10 - 2013-09-04 17:58 - Sascha Egerer

Can't reproduce this issue in current master (6.2).

#11 - 2013-09-17 17:48 - Ernesto Baschny
- Subject changed from PHP Catchable Fatal Error: t3lib_iconWorks::getSpriteIconForRecord() must be an array to PHP Catchable Fatal Error: 
t3lib_iconWorks::getSpriteIconForRecord() must be an array (workspaces situation)
- Category set to Workspaces
- Target version deleted (4.5.12)
- Is Regression set to No

This seem to be a bug in typo3/sysext/backend/Classes/View/PageLayoutView.php in workspace mode. Remains to be further analysed.

#12 - 2013-09-17 17:52 - Ernesto Baschny
- Status changed from New to Needs Feedback

In fact there even seem to be a potential solution. Check out #21084 and the patch in the review queue if this solves it for you.

#13 - 2013-11-22 09:03 - Alexander Opitz

It would be nice if we can get response from the users if the patch from #21084 fixes this problem here.
#14 - 2014-03-10 12:04 - Alexander Opitz

No feedback within the last 90 days => closing this ticket.

If you think that this is the wrong decision or experience this issue again, then please write to the mailing list typo3.teams.bugs with issue number and
an explanation or open a new ticket and add a relation to this ticket number.

#15 - 2014-03-10 12:05 - Alexander Opitz
- Status changed from Needs Feedback to Closed

Files
25372.diff 1.4 kB 2011-09-07 Fedir RYKHTIK
